<?php

namespace Drupal\openlayers\Controller;

use Drupal\Core\Config\Entity\ConfigEntityListBuilder;
use Drupal\Core\Entity\EntityInterface;

/**
 * Provides a listing of Openalyers Source configuration entities.
 */
class OpenlayersSourceListBuilder extends ConfigEntityListBuilder {

  /**
   * {@inheritdoc}
   */
  public function buildHeader() {
    $header['label'] = $this->t('Source');
    $header['id'] = $this->t('Machine name');
    $header['service'] = $this->t('Factory service');

    return $header + parent::buildHeader();
  }

  /**
   * {@inheritdoc}
   */
  public function buildRow(EntityInterface $entity) {
    $row['label'] = $entity->label();
    $row['id'] = $entity->id();
    $row['service'] = $entity->service();

    return $row + parent::buildRow($entity);
  }

}