<?php

namespace Drupal\openlayers\Entity;

use Drupal\Core\Config\Entity\ConfigEntityBase;
use Drupal\openlayers\OpenlayersComponentInterface;

/**
 * Defines the Openlayers Component entity.
 *
 * @ConfigEntityType(
 *   id = "openlayers_component",
 *   label = @Translation("Openlayers Component"),
 *   handlers = {
 *     "list_builder" = "Drupal\openlayers\Controller\OpenlayersComponentListBuilder",
 *     "form" = {
 *       "add" = "Drupal\openlayers\Form\OpenlayersComponentAddForm",
 *       "edit" = "Drupal\openlayers\Form\OpenlayersComponentEditForm",
 *       "delete" = "Drupal\openlayers\Form\OpenlayersComponentDeleteForm",
 *     }
 *   },
 *   config_prefix = "component",
 *   admin_permission = "administer openlayers",
 *   entity_keys = {
 *     "id" = "id",
 *     "label" = "label",
 *   },
 *   config_export = {
 *     "id",
 *     "label",
 *     "is_configurable",
 *     "pluginId",
 *     "service",
 *     "options"
 *   },
 *   links = {
 *     "edit-form" = "/admin/config/system/openlayers/component/{openlayers_component}/edit",
 *     "delete-form" = "/admin/config/system/openlayers/component/{openlayers_component}/delete",
 *   }
 * )
 */
class OpenlayersComponent extends ConfigEntityBase implements OpenlayersComponentInterface {

  /**
   * The Example ID.
   *
   * @var string
   */
  public $id;

  /**
   * The Example label.
   *
   * @var string
   */
  public $label;

  /**
   * The factory service.
   *
   * @var string
   */
  public $service;

  // Your specific configuration property get/set methods go here,
  // implementing the interface.

  /**
   * {@inheritdoc}
   */
  public function id() {
    return $this->get('id');
  }

  /**
   * {@inheritdoc}
   */
  public function label() {
    return $this->label;
  }

  /**
   * {@inheritdoc}
   */
  public function service() {
    return $this->service;
  }

  /**
   * {@inheritdoc}
   */
  public function getType() {
    return $this->get('service');
  }

}
