<?php

namespace Drupal\openlayers\Plugin\Source\XYZ;

use Drupal\Core\Form\FormStateInterface;
use Drupal\openlayers\Types\Source;
//use Drupal\Component\Utility\Color;
//use Drupal\Component\Utility\Rectangle;

/**
 * Defines the XYZ source for an Openlayers map.
 *
 * @OpenlayersPlugin(
 *   id = "ol_source_xyz",
 *   label = @Translation("XYZ"),
 *   description = @Translation("Define an XYZ source."),
 *   service = "openlayers.Source:XYZ",
 *   library = "openlayers-plugin-source-xyz",
 *   is_configurable = "true",
 *   type = "source"
 * )
 */
class XYZ extends Source {

  /**
   * {@inheritdoc}
   */
  public function getSummary() {
    $summary = [
      '#theme' => 'openlayers_source_xyz_summary',
      '#data' => $this->configuration,
    ];
    $summary += parent::getSummary();

    return $summary;
  }

  /**
   * {@inheritdoc}
   */
  public function defaultConfiguration() {
    return [
      'className' => 'ol-source',
      'collapsible' => TRUE,
      'collapsed' => FALSE,
      'tipLabel' => 'Attributions',
      'label' => 'aaaaaaaaaaaaaa',
      'collapseLabel' => 'bbbbbbbbbbbbbbbb',      
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function buildConfigurationForm(array $form, FormStateInterface $form_state) {
    $form['className'] = [
      '#type' => 'textfield',
      '#default_value' => $this->configuration['className'],
      '#title' => t('Class name'),
      '#description' => t('CSS class name.'),
      '#size' => 50,
      '#maxlength' => 50,
      '#required' => FALSE,
    ];
/*
    $form['collapsible'] = array(
      '#type' => 'checkbox',
      '#title' => $this->t('Collapsible'),
      '#description' => t('Specify if attributions can be collapsed.'),
      '#default_value' => $this->configuration['collapsible'],
    );
    $form['collapsed'] = array(
      '#type' => 'checkbox',
      '#title' => $this->t('Collapsed'),
      '#description' => t('Specify if attributions should be collapsed at startup.'),
      '#default_value' => $this->configuration['collapsed'],        //  Specify if attributions can be collapsed.
    );
    $form['tipLabel'] = [
      '#type' => 'textfield',
      '#default_value' => $this->configuration['tipLabel'],
      '#title' => t('Tip label'),
      '#description' => t('Text label to use for the button tip.'),
      '#size' => 100,
      '#maxlength' => 100,
      '#required' => FALSE,
    ];
    $form['label'] = [
      '#type' => 'textfield',
      '#default_value' => $this->configuration['label'],
      '#title' => t('Label'),
      '#description' => t('Text label to use for the collapsed attributions button.'),
      '#size' => 100,
      '#maxlength' => 100,
      '#required' => FALSE,
    ];
    $form['collapseLabel'] = [
      '#type' => 'textfield',
      '#default_value' => $this->configuration['collapseLabel'],
      '#title' => t('Collapse label'),
      '#description' => t('Text label to use for the expanded attributions button.'),
      '#size' => 100,
      '#maxlength' => 100,
      '#required' => FALSE,
    ];
*/
    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function validateConfigurationForm(array &$form, FormStateInterface $form_state) {
/*
    if (!$form_state->isValueEmpty('color') && !Color::validateHex($form_state->getValue('color'))) {
      $form_state->setErrorByName('color', $this->t('Color must be a hexadecimal color value.'));
    }
*/
  }

  /**
   * {@inheritdoc}
   */
  public function submitConfigurationForm(array &$form, FormStateInterface $form_state) {
    parent::submitConfigurationForm($form, $form_state);

    $this->configuration['className'] = $form_state->getValue('className');
/*
    $this->configuration['collapsible'] = $form_state->getValue('collapsible');
    $this->configuration['collapsed'] = $form_state->getValue('collapsed');
    $this->configuration['tipLabel'] = $form_state->getValue('tipLabel');
    $this->configuration['label'] = $form_state->getValue('label');
    $this->configuration['collapseLabel'] = $form_state->getValue('collapseLabel');
*/
  }

}
